/*
 * |-----------------------------------------------------------|
 * | Copyright (c) 1991, 1990 MIPS Computer Systems, Inc.      |
 * | All Rights Reserved                                       |
 * |-----------------------------------------------------------|
 * |          Restricted Rights Legend                         |
 * | Use, duplication, or disclosure by the Government is      |
 * | subject to restrictions as set forth in                   |
 * | subparagraph (c)(1)(ii) of the Rights in Technical        |
 * | Data and Computer Software Clause of DFARS 252.227-7013.  |
 * |         MIPS Computer Systems, Inc.                       |
 * |         950 DeGuigne Avenue                               |
 * |         Sunnyvale, California 94088-3650, USA             |
 * |-----------------------------------------------------------|
 */
#ident	"$Header: unix.c,v 1.8.3.1 92/06/24 13:40:25 marker Exp $"

/*-
 * Copyright (c) 1983, 1988 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted provided
 * that: (1) source distributions retain this entire copyright notice and
 * comment, and (2) distributions including binaries display the following
 * acknowledgement:  ``This product includes software developed by the
 * University of California, Berkeley and its contributors'' in the
 * documentation or other materials provided with the distribution and in
 * all advertising materials mentioning features or use of this software.
 * Neither the name of the University nor the names of its contributors may
 * be used to endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef lint
static char sccsid[] = "@(#)unix.c	5.9 (Berkeley) 6/18/90";
#endif /* not lint */

/*
 * Display protocol blocks in the unix domain.
 */
#include <sys/param.h>
#include <sys/protosw.h>
#include <sys/socket.h>
#include <sys/socketvar.h>
#include <sys/mbuf.h>
#include <sys/un.h>
#include <sys/unpcb.h>

#ifdef _RISCOS
#include <sysv/sys/var.h>   /* System Configuration information structure */
#endif _RISCOS
#define KERNEL
#define _KERNEL
#include <sys/file.h> 

int	Aflag;
extern	char *calloc();

#ifdef _RISCOS
unixpr (vaddr, fileaddr, unixsw)
	off_t vaddr, fileaddr;
	struct protosw *unixsw;
#else _RISCOS
unixpr(nfileaddr, fileaddr, unixsw)
	off_t nfileaddr, fileaddr;
	struct protosw *unixsw;
#endif _RISCOS
{
	register struct file *fp;
#ifdef _RISCOS
	struct var v;
	struct file *prev_filep;
	struct file file;
#endif _RISCOS
	struct file *filep;
	struct socket sock, *so = &sock;

#ifdef _RISCOS
	if (vaddr == 0) {
		printf("v address not in namelist.\n");
		return;
	}
	if (fileaddr == 0) {
		printf("file not in namelist.\n");
		return;
	}
	if (kvm_read((off_t) vaddr, &v, sizeof (v)) != sizeof (v)) {
		printf("v structure: bad read.\n");
		return;
	}
#else _RISCOS
	if (nfileaddr == 0 || fileaddr == 0) {
		printf("nfile or file not in namelist.\n");
		return;
	}
	if (kvm_read(nfileaddr, (char *)&nfile, sizeof (nfile)) !=
						sizeof (nfile)) {
		printf("nfile: bad read.\n");
		return;
	}
#endif _RISCOS
	if (kvm_read(fileaddr, (char *)&filep, sizeof (filep))
						!= sizeof (filep)) {
		printf("File table address, bad read.\n");
		return;
	}
#ifdef _RISCOS
	prev_filep = NULLFP;
	while (filep != NULLFP) {
		if (kvm_read((off_t)filep, &file, sizeof (struct file)) !=
				sizeof (struct file)) {
			printf("File table read error.\n");
			return;
		}
		if (prev_filep != file.f_prev) {
			printf("File table changed during scan. Try again.\n");
			return;
		}
		prev_filep = filep;
		filep = file.f_next;

		if (file.f_count == 0 || file.f_type != DTYPE_SOCKET)
		  continue;
		if (kvm_read((off_t) file.f_data, so, sizeof (*so))
				 != sizeof (*so)) continue;
		/* kludge */
		if (so->so_proto >= unixsw && so->so_proto <= unixsw + 2)
			if (so->so_pcb)
				unixdomainpr(so, file.f_data);
	}
#else _RISCOS
	file = (struct file *)calloc(nfile, sizeof (struct file));
	if (file == (struct file *)0) {
		printf("Out of memory (file table).\n");
		return;
	}
	if (kvm_read((off_t)filep, (char *)file, nfile * sizeof (struct file))
					!= nfile * sizeof (struct file)) {
		printf("File table read error.\n");
		return;
	}
	fileNFILE = file + nfile;
	for (fp = file; fp < fileNFILE; fp++) {
		if (fp->f_count == 0 || fp->f_type != DTYPE_SOCKET)
		  continue;
		if (kvm_read((off_t)fp->f_data, (char *)so, sizeof (*so))
					!= sizeof (*so))
			continue;
		/* kludge */
		if (so->so_proto >= unixsw && so->so_proto <= unixsw + 2)
			if (so->so_pcb)
				unixdomainpr(so, fp->f_data);
	}
	free((char *)file);
#endif _RISCOS
}

static	char *socktype[] =
    { "#0", "stream", "dgram", "raw", "rdm", "seqpacket" };

unixdomainpr(so, soaddr)
	register struct socket *so;
	caddr_t soaddr;
{
	struct unpcb unpcb, *unp = &unpcb;
	struct mbuf mbuf, *m;
	struct sockaddr_un *sa;
	static int first = 1;
#ifdef _RISCOS
	char	mbuf_extra[sizeof(struct sockaddr_un)];
#endif _RISCOS

	if (kvm_read((off_t)so->so_pcb, (char *)unp, sizeof (*unp))
				!= sizeof (*unp))
		return;
	if (unp->unp_addr) {
		m = &mbuf;
		if (kvm_read((off_t)unp->unp_addr, (char *)m, sizeof (*m))
				!= sizeof (*m))
			m = (struct mbuf *)0;
#ifdef _RISCOS
		else {
			if (m->m_data >= (caddr_t) unp->unp_addr &&
			    m->m_data <
				 (caddr_t) (((struct mbuf *) unp->unp_addr) + 1))
				m->m_data = (caddr_t) m +
					(m->m_data - ((caddr_t) unp->unp_addr));
			else {
				if (kvm_read((off_t) m->m_data,
					     mbuf_extra,sizeof(mbuf_extra)) !=
					sizeof(mbuf_extra)) 
					m = (struct mbuf *) 0;
				else
					m->m_data = mbuf_extra;
			}
		}			
		if (m)
			sa = mtod(m, struct sockaddr_un *);
#else _RISCOS
		sa = (struct sockaddr_un *)(m->m_dat);
#endif _RISCOS
	} else
		m = (struct mbuf *)0;
	if (first) {
		printf("Active UNIX domain sockets\n");
		printf(
"%-8.8s %-6.6s %-6.6s %-6.6s %8.8s %8.8s %8.8s %8.8s Addr\n",
		    "Address", "Type", "Recv-Q", "Send-Q",
#ifdef _RISCOS
		    "Vnode", "Conn", "Refs", "Nextref");
#else _RISCOS
		    "Inode", "Conn", "Refs", "Nextref");
#endif _RISCOS
		first = 0;
	}
	printf("%8x %-6.6s %6d %6d %8x %8x %8x %8x",
	    soaddr, socktype[so->so_type], so->so_rcv.sb_cc, so->so_snd.sb_cc,
	    unp->unp_vnode, unp->unp_conn,
	    unp->unp_refs, unp->unp_nextref);
	if (m)
		printf(" %.*s", m->m_len - sizeof(sa->sun_family),
		    sa->sun_path);
	putchar('\n');
}
